
#include "TreeToXML.h"
#include <string>
#include <iostream>
#include <sstream>
using namespace std;

// should we output all the individuals into an xml file ?
bool xmloutputon = false;
// the file to output to
xml::Project *project;
xml::individuals *indi;
xml::representation *actualrep;

// hte name of this file
char* xmlfilename = 0;

											

/* should not be called if xmloutputon is false ! */
void SetupXMLOutput()
{
	project = new xml::Project(xmlfilename, 1, "ECJAVA and XML GP test", "test", "today", "SNU", "$$$" );

	indi = project->newexperiments()->newexperiment(1,"today","essai")->newtreatments()->newtreatment(1,"treatment")->newtrials()->newtrial(1)->newgenerations()->newgeneration(1)->newindividuals();

	actualrep = NULL;
}

/* should not be called if xmloutputon is false ! */
void FinishXMLOutput()
{	
	delete project;
}

void ConvertToXML(individual v, int gen, int ind)
{
	stree s = Decode(v,FALSE);
	actualrep = indi->newindividual(ind)->newrepresentations()->newrepresentation(1,"tree");

	PrintToXML(s.root,NULL);

}

void PrintToXML( node* n, xml::children* c )
{
	if( n->children == NULL )
	{
		// terminal : 
		string s;
		if( n->name[0] == 'R' )
		{

			stringstream out;
			out << n->value;
			s = out.str();
		}
		else
		{
			s = n->name;
		}
		
		if( c == NULL ) // racine
		{
			actualrep->newNode( s , "terminal" );
		}
		else
		{	
			c->newNode( s , "terminal" );
		}

	}
	else // les fils !
	{
		xml::Node* newnode;
		if( c == NULL ) // racine
		{
			newnode = actualrep->newNode( n->name , "nonterminal" );
		}
		else
		{	
			newnode = c->newNode( n->name, "nonterminal" );
		}
	
		// affiche les fils :
		PrintToXML(n->children, newnode->newchildren() );
	}
	// affiche les freres :
	if( n->sibling != NULL )
	{
			PrintToXML(n->sibling, c );
	} 
}




