#include "generateur.h"

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

FILE *header,*source;
char raccourcis[5000];
char classedejafaite[20];

/* various initialization... */
void init()
{
	ClassName = malloc( sizeof(Pile) );
	ClassName->str = 0;
	ClassName->precedent = 0;
	ClassName->suivant = 0;
	ClassName->nbattr = 0;
	ClassName->nbelem = 0;
	ClassName->cpt = 0;
	// le bas de la pile
	ClassNameBottom = ClassName;
}


/* generate the "class name" part of the file */
/* it output a correct header file, with the #define, #include etc
/* to be called only once, when parsing the root element ! */
void creer_classe(char* name)
{

	ClassName->str = malloc( strlen(name) + 1 );
	strcpy(ClassName->str, name );
	
	/* ouverture du fichier header*/
	char *filename = malloc( strlen(name) + 1 + 2 );
	strcpy(filename,name);
	strcat(filename,".h");
	header = fopen( filename , "w" );
	free(filename);

	/* ouverture du fichier source */
	filename = malloc( strlen(name) + 1 + 4 );
	strcpy(filename,name);
	strcat(filename,".cpp");
	source = fopen( filename , "w" );
	free(filename);

	/* en-tete header*/
	char entete[300];
	strcpy(entete,"#ifndef _");
	strcat(entete,name);
	strcat(entete,"_H_ \n\t#define _");
	strcat(entete,name);
	strcat(entete,"_H_ \n \n#include <iostream>\n#include <fstream>\n#include <string.h>\n#include <string>\nusing namespace std;\n\n");
	fprintf(header,entete);

	/* en-tete source */
	char entetesource[200];	
	strcpy(entetesource,"#include \"");
	strcat(entetesource,name);
	strcat(entetesource,".h\"\n\n");
	fprintf(source,entetesource);

	fprintf(header,"fstream out;\n");

	/* creation de la classe */
	fprintf(header,"class %s{\n",name);
	fprintf(header,"public : \n");

	// destructeur 
	indent(0);
	fprintf(header,"~%s();\n",name);

	
	fprintf(source,"%s::~%s(){\n",name,name);
	fprintf(source,"effacer();\n");
	indentxml();
	fprintf(source,"out<<\"</%s>%c%c\";\n}\n\n",name,'\\','n');
}


/* output the closing bracket that finishes the class definition */
/* to be called when finishing parsing of the Schema root element */
void finir_classe()
{
	fprintf(header,raccourcis);
	fprintf(header,"#endif");
}

/* add an attribute to the current element */
void attribute(char* name, char* type)
{
	// ajoute l'attribut a la liste
	ClassName->attr[ClassName->nbattr] = malloc( sizeof(Attribut) );
	ClassName->attr[ClassName->nbattr]->contraintes = NULL;
	ClassName->attr[ClassName->nbattr]->nom = malloc( strlen(name) + 1 );
	strcpy( ClassName->attr[ClassName->nbattr]->nom , name );
		
	indent(0); // element type : string or integer... add Dates, float and other types here.
	if( strcmp(&type[4],"string") == 0 )
	{
		fprintf(header,"string %s;\n",name);
		ClassName->attr[ClassName->nbattr]->type = malloc( strlen("string") + 1 );
		strcpy( ClassName->attr[ClassName->nbattr]->type , "string" );

	}
	else if( strcmp(&type[4],"integer") == 0 )
	{
		fprintf(header,"int %s;\n",name);
		ClassName->attr[ClassName->nbattr]->type = malloc( strlen("int") + 1 );
		strcpy( ClassName->attr[ClassName->nbattr]->type , "int" );
	}
	else
	{
		printf("ERREUR type %s inconnu \n",type);
	}
	ClassName->nbattr++;
}

/* restriction sur les valeurs des attributs */
/* constraint on attributes values */
/* add an attribute to the element, that contains a constraint, either a String constraint or an integer constraint */
/* the constraint is/are contained in the list l.
void attribute_contraint(char* name, char* type, struct liste *l)
{
	attribute(name,type);
	ClassName->attr[ClassName->nbattr-1]->contraintes = l->suivant;
}

/* ajoute un element sous la forme d'une classe */
/* adds a new element "child element" : creates a new class in the header file, a nested class. */
void ajouter_element(char* name)
{
	// ajoute l'element a la liste :
	ClassName->elem[ClassName->nbelem] = malloc( sizeof(Attribut) );
	ClassName->elem[ClassName->nbelem]->nom = malloc( strlen(name) + 1 );
	strcpy(ClassName->elem[ClassName->nbelem]->nom, name );
	ClassName->elem[ClassName->nbelem]->type = malloc( strlen("list") + 1 );
	strcpy(ClassName->elem[ClassName->nbelem]->type, "list" );
	ClassName->nbelem++;
	

	if( ! already_done_element(name) )
	{
		Pile* nouveau = malloc( sizeof(Pile) );
		nouveau->str = malloc( strlen(name) + 1 );
		strcpy(nouveau->str, name );

		nouveau->cpt = ClassName->cpt + 1;
		nouveau->nbattr = 0;
		nouveau->nbelem = 0;
		// sommet de la pile 
		nouveau->precedent = ClassName;
		nouveau->suivant = 0;
		ClassName->suivant = nouveau;



		indent(0);
		fprintf(header,"class %s{\n",name);
		indent(0);
		fprintf(header,"public:\n",name);

		ClassName = nouveau;	


		// destructeur 
		indent(0);
		fprintf(header,"~%s();\n",name);

		Pile* temp = ClassNameBottom;	
		while(temp)
		{
				fprintf(source,"%s::",temp->str);
				temp = temp->suivant;
		}

		fprintf(source,"~%s(){\n",name,name);
		fprintf(source,"effacer();\n");
		indentxml();
		fprintf(source,"out<<\"</%s>%c%c\";\n}\n\n",name,'\\','n');

	}
}

/* finish the class : output constructor, accessors... */
void finir_element()
{
	int deja_fait = 0;

	if( already_done_element("") )
		deja_fait = 1;

	if(!deja_fait)
	{
			// constructeur :
			indent(0);
			if( ClassName == ClassNameBottom )
			{
				fprintf(header,"%s(string filename ",ClassName->str);
			}
			else
			{
				fprintf(header,"%s(int parent_esp ",ClassName->str);
			}

			for(int i=0; i<ClassName->nbattr; i++ )
			{
				fprintf(header,", ");
				fprintf(header,"%s _%s",ClassName->attr[i]->type,ClassName->attr[i]->nom);
			}
			fprintf(header,");\n");

			Pile *temp = ClassNameBottom;	
			while(temp)
			{
				fprintf(source,"%s::",temp->str);
				temp = temp->suivant;
			}
			if( ClassName == ClassNameBottom )
			{
				fprintf(source,"%s(string filename ",ClassName->str);
			}
			else
			{
				fprintf(source,"%s(int parent_esp ",ClassName->str);
			}
			for(int i=0; i<ClassName->nbattr; i++ )
			{
				fprintf(source,", ");
				fprintf(source,"%s _%s",ClassName->attr[i]->type,ClassName->attr[i]->nom);
			}
			fprintf(source,"){\n");

			for(int i=0; i<ClassName->nbattr; i++ )
			{
				/* verification de la correctness des attributs */
				if( ClassName->attr[i]->contraintes != NULL )
				{
					if( strcmp(ClassName->attr[i]->type,"string") == 0 )
					{	
						fprintf(source,"/* verication de type */ \nif( ");
						Liste* temp = ClassName->attr[i]->contraintes;
						while( temp != NULL )
						{
							fprintf(source,"(strcmp(_%s.c_str(),\"%s\") != 0)",ClassName->attr[i]->nom,temp->str);
							temp = temp->suivant;
							if( temp != NULL )
							{
								fprintf(source,"&&");
							}
						}
						fprintf(source," ){\n cout<<\"erreur de type !\"<<endl;\nreturn;\n}\n");
					}
					if( strcmp(ClassName->attr[i]->type,"int") == 0 )
					{	
						fprintf(source,"/* verication de type */ \nif(!( ");
						Liste* temp = ClassName->attr[i]->contraintes;
						while( temp != NULL )
						{
							fprintf(source,"(_%s %s)",ClassName->attr[i]->nom,temp->str);
							temp = temp->suivant;
							if( temp != NULL )
							{
								fprintf(source,"&&");
							}
						}
						fprintf(source," )){\n cout<<\"erreur de type !\"<<endl;\nreturn;\n}\n");
					}
				}
			}
			if( ClassName == ClassNameBottom )
			{
				fprintf(source,"\tout.open(filename.c_str(), fstream::out);\n");
				fprintf(source,"espacement=0;\n");
			}	
			else
			{		
				fprintf(source,"espacement=parent_esp+1;\n");
			}
			fprintf(source,"init();\n");
			fprintf(source,"WriteAttributes(");
			for(int i=0; i<ClassName->nbattr; i++ )
			{
				fprintf(source,"_%s",ClassName->attr[i]->nom);
				if(i != ClassName->nbattr-1 )
					fprintf(source,", ");
			}
			fprintf(source,");\n");
			fprintf(source,"}\n\n");
	

		// ecrit les accesseurs pour les attributs */
		ecrire_attributs();

		// ecrit l'initialisation des elements fils :
		indent(0);
		fprintf(header,"void init();\n");
		fprintf(source,"void ");

		temp = ClassNameBottom;	
		while(temp)
		{
			fprintf(source,"%s::",temp->str);
			temp = temp->suivant;
		}

		fprintf(source,"init(){\n");
		for(int i=0; i< ClassName->nbelem; i++ )
		{
			fprintf(source,"_%s = NULL;\n",ClassName->elem[i]->nom);
		}
		fprintf(source,"}\n\n");

		/* ecrit le destructeur : */
		indent(0);		
		fprintf(header,"void effacer();\n");
		fprintf(source,"void ");

		temp = ClassNameBottom;	
		while(temp)
		{
			fprintf(source,"%s::",temp->str);
			temp = temp->suivant;
		}

		fprintf(source,"effacer(){\n");
		for(int i=0; i< ClassName->nbelem; i++ )
		{
			fprintf(source,"if( _%s != NULL ) \n delete _%s; \n",ClassName->elem[i]->nom,ClassName->elem[i]->nom);
		}
		fprintf(source,"}\n\n");

		// ferme la classe
		indent(1);
		fprintf(header,"};\n");
	}
	
	if( ClassName != ClassNameBottom )
	{
		if( !deja_fait )
		{
			// objet membre + accesseur :
			indent(1);
			fprintf(header,"int espacement;\n",ClassName->str,ClassName->str);
			indent(1);
			fprintf(header,"%s* _%s;\n",ClassName->str,ClassName->str);
			indent(1);
			fprintf(header,"%s* get%s();\n",ClassName->str,ClassName->str);
			indent(1);
			fprintf(header,"%s* new%s(",ClassName->str,ClassName->str);
			for(int i=0; i<ClassName->nbattr; i++ )
			{
				fprintf(header,"%s _%s",ClassName->attr[i]->type,ClassName->attr[i]->nom);
				if(i != ClassName->nbattr-1 )
					fprintf(header,", ");
			}
			fprintf(header,");\n");
			// et dans la source :
			fprintf(source,"%s* ",ClassName->str);
			Pile* temp = ClassNameBottom;	
			while(1)
			{
					fprintf(source,"%s::",temp->str);
					temp = temp->suivant;
					if(temp == ClassName)
						break;
			}

			fprintf(source,"get%s(){\n",ClassName->str);
			fprintf(source,"return _%s;\n",ClassName->str);
			fprintf(source,"}\n\n");

			// le nouveau fils
			fprintf(source,"%s* ",ClassName->str);
			temp = ClassNameBottom;	
			while(1)
			{
					fprintf(source,"%s::",temp->str);
					temp = temp->suivant;
					if(temp == ClassName)
						break;
			}
			fprintf(source,"new%s(",ClassName->str);

			for(int i=0; i<ClassName->nbattr; i++ )
			{
				fprintf(source,"%s _%s",ClassName->attr[i]->type,ClassName->attr[i]->nom);
				if(i != ClassName->nbattr-1 )
					fprintf(source,", ");
			}
			fprintf(source,"){\n");
			fprintf(source,"if( _%s != NULL ) \n delete _%s; \n",ClassName->str,ClassName->str);
			fprintf(source,"_%s = new %s(espacement",ClassName->str,ClassName->str);
			for(int i=0; i<ClassName->nbattr; i++ )
			{
				fprintf(source,", ");
				fprintf(source,"_%s",ClassName->attr[i]->nom);
			}
			fprintf(source,");\n");
			fprintf(source,"return _%s;\n",ClassName->str);
			fprintf(source,"}\n\n");

			// sauvegarde avant de depiler :
			strcat(raccourcis,"typedef ");
			temp = ClassNameBottom;	
			while(temp)
			{
					strcat(raccourcis,temp->str);
					temp = temp->suivant;
					if(temp)
						strcat(raccourcis,"::");
			}
			strcat(raccourcis," ");
		//	strcat(raccourcis,"xml_"); this was an attempt to escape from "already defined class" errors. A better way is to simply wrap all the class in a namespace.
			strcat(raccourcis,ClassName->str);
			strcat(raccourcis,";\n");

			// depile
			ClassName = ClassName->precedent;
			free(ClassName->suivant);
			ClassName->suivant = 0;
		}	
		else // la classe a deja ete faite mais il faut les membres
		{
			// objet membre + accesseur :
			indent(0);
			fprintf(header,"int espacement;\n",ClassName->str,ClassName->str);
			indent(0);
			fprintf(header,"%s* _%s;\n",classedejafaite,classedejafaite);
			indent(0);
			fprintf(header,"%s* get%s();\n",classedejafaite,classedejafaite);
			indent(0);
			/* plus complique : faut recuperer l'ancien prototype : */
			fprintf(header,"%s* new%s(");
			Pile* AncienneClasse = rechercher(classedejafaite);
			for(int i=0; i<AncienneClasse->nbattr; i++ )
			{
				fprintf(header,"%s _%s",AncienneClasse->attr[i]->type,AncienneClasse->attr[i]->nom);
				if(i != AncienneClasse->nbattr-1 )
					fprintf(header,", ");
			}
			fprintf(header,");\n");



			// le nouveau fils
			fprintf(source,"%s* ",classedejafaite);
			Pile* temp = ClassNameBottom;	
			while(1)
			{
					fprintf(source,"%s::",temp->str);
					temp = temp->suivant;
					if(temp == ClassName)
						break;
			}
			fprintf(source,"%s::",ClassName->str);
			fprintf(source,"new%s(",classedejafaite);
			for(int i=0; i<AncienneClasse->nbattr; i++ )
			{
				fprintf(source,"%s _%s",AncienneClasse->attr[i]->type,AncienneClasse->attr[i]->nom);
				if(i != AncienneClasse->nbattr-1 )
					fprintf(source,", ");
			}
			fprintf(source,"){\n");
			fprintf(source,"if( _%s != NULL ) \n delete _%s; \n",classedejafaite,classedejafaite);
			fprintf(source,"_%s = new %s(espacement",classedejafaite,classedejafaite);
			for(int i=0; i<AncienneClasse->nbattr; i++ )
			{
				fprintf(source,", ");
				fprintf(source,"_%s",AncienneClasse->attr[i]->nom);

			}
			fprintf(source,");\n");
			fprintf(source,"return _%s;\n",classedejafaite);
			fprintf(source,"}\n\n");
		}
	}
}

/* ecrit la methode qui permet de creer cet element : 'creer(arguments...)' */
void ecrire_attributs()
{
	// dans le header
	indent(0);
	fprintf(header,"void WriteAttributes(");
	
	for(int i=0; i<ClassName->nbattr; i++ )
	{
		fprintf(header,"%s _%s",ClassName->attr[i]->type,ClassName->attr[i]->nom);
		if(i != ClassName->nbattr-1 )
			fprintf(header,", ");
	}
	fprintf(header,");\n");

	// et dans la source :
	fprintf(source,"void ");

	Pile *temp = ClassNameBottom;	
	while(temp)
	{
			fprintf(source,"%s::",temp->str);
			temp = temp->suivant;
	}
	
	fprintf(source,"WriteAttributes(");
	
	for(int i=0; i<ClassName->nbattr; i++ )
	{
		fprintf(source,"%s _%s",ClassName->attr[i]->type,ClassName->attr[i]->nom);
		if(i != ClassName->nbattr-1 )
			fprintf(source,", ");
	}
	fprintf(source,"){\n");
	

	// ecrit le contenu sous forme de XML dans le fichier output :
	
	indentxml();
	fprintf(source,"out<<\"<%s",ClassName->str);
	for(int i=0; i<ClassName->nbattr; i++ )
	{
		//ecrit les attributs :	
		fprintf(source," %s=%c%c\"<<_%s<<\"%c%c",ClassName->attr[i]->nom,'\\',34,ClassName->attr[i]->nom,'\\',34);
	}
	fprintf(source,">%c%c\";\n",'\\','n');
	fprintf(source,"}\n\n");
}

/*indentation de la classe generee*/
void indent(int _i)
{
	for(int i=_i; i<=ClassName->cpt; i++ )
	{
		fprintf(header,"\t");	
	}
}

/*indentation du xml final*/
void indentxml()
{
	fprintf(source,"for(int i=0; i<espacement; i++ ) \n\
{ \n \
	out<<\"\t\";	\n\
} \n");

}


/* retourne 1 si l'element a deja ete ecrit (elements imbriques 
, cas des arbres par exemple */
/* return 1 if the element was already written before. It's used to handle recursivity, for exemple Node containing childs containing Nodes... */
int already_done_element(char* name)
{
	printf("on cherche %s \n",name);

	static int commence = 0;

	if( strcmp(name,"") == 0 )
	{
		if( commence == 1 )
		{
			commence = 0;
			return 1;
		}
		else
		{
			return 0;
		}
	}

	strcpy(classedejafaite,name); // name of the element. It was already dealt with (class def) but we may want to use it in another way.
	
	// cherche voir si le name est pas deja present dans la pile
	Pile *temp = ClassNameBottom;	
	while(temp)
	{
			printf("%s\n",temp->str);
			if( strcmp(temp->str,name) == 0 )
			{
				commence = 1;
				return 1;	
			}
			temp = temp->suivant;
	}

	// pas trouve !
	return 0;
}

/* looks for an element in the heap of already dealt with elements */
Pile* rechercher(char* name)
{
	Pile *temp = ClassNameBottom;	
	while(temp)
	{
			printf("%s\n",temp->str);
			if( strcmp(temp->str,name) == 0 )
			{
				return temp;	
			}
			temp = temp->suivant;
	}
	return NULL;
}


