// @author Marhic Jerome
// parses an xml schema 
// and creates an adequate c++ class to write a corresponding document


%{
#  include <stdio.h>
#include "generateur.h"
#include <string.h>
//#include "utilities.h"

struct listetypee
{
	struct liste* l;
	char t[20];
};

%}



%union {
  char s[20];
  struct liste *l; /* liste de char* */
  struct listetypee *lt; 
  int i;
}

/* declare tokens */
%token  ELEMENT
%token <s> IDENT
%token NAME  
%token COMPLEXTYPE  
%token SEQUENCE  
%token TYPE BASE 
%token ATTRIBUTE   
%token <l> RESTRICTION
%token <l> ENUMERATION
%token VALUE
%token <i> MININCLUSIVE
%token <s> NUMBER
%type <l> enumeration
%type <lt> restriction
%type <l> mininclusive

/* exemple of a xml schema 

<xsd:element name="book">
 <xsd:complexType>
  <xsd:sequence>
   <xsd:element name="title" type="xsd:string"/>
   <xsd:element name="author" type="xsd:string"/>
   <xsd:element name="character"
        minOccurs="0" maxOccurs="unbounded">
    <xsd:complexType>
     <xsd:sequence>
      <xsd:element name="name" type="xsd:string"/>
      <xsd:element name="friend-of" type="xsd:string"
	    minOccurs="0" maxOccurs="unbounded"/>
      <xsd:element name="since" type="xsd:date"/>
      <xsd:element name="qualification" type="xsd:string"/>
     </xsd:sequence>
    </xsd:complexType>
   </xsd:element> 
  </xsd:sequence>
  <xsd:attribute name="isbn" type="xsd:string"/>
 </xsd:complexType>
</xsd:element> 
*/
%%

schema : 
	root
	;

choix :  
	choix superseq 
	| choix supercmp 
	| choix superelt 
	| choix attribute 
	| superseq
	| supercmp
	| superelt
	| attribute
	|
	;

root : 
	'<' ELEMENT NAME '=' '"' IDENT '"' '>' {  creer_classe($6); } choix closeelt { finir_classe(); }
	;
/**********************************/
/**** SEQUENCE 
***********************************/


superseq :
	sequence choix closeseq	
	| sequence closeseq
	;

sequence : 
	'<' SEQUENCE '>' { printf("ok seq \n"); } 
	;

closeseq :
	'<' '/' SEQUENCE '>' { printf("ok closeseq \n"); } 
	;

/**********************************/
/**** COMPLEXTYPE 
***********************************/


supercmp :
	complexe choix closecmp
	| complexe closecmp
	;

complexe :
	'<' COMPLEXTYPE '>' { printf("ok complexe \n"); } 
	;

closecmp:
	'<' '/' COMPLEXTYPE '>' { printf("ok closecpl \n"); }
	;

/**********************************/
/**** ELEMENT 
***********************************/


superelt : 
	element closeelt  
	| element choix closeelt 
	| simpleelt { printf("ok element \n"); } 
	;

simpleelt :
	'<' ELEMENT NAME '=' '"' IDENT '"' '/' '>' { ajouter_element($6); finir_element();  }
	| '<' ELEMENT NAME '=' '"' IDENT '"' TYPE '=' '"' IDENT '"' '/' '>' 
	;

element :
	elementtype
	| elementnontype
	;

elementnontype : 
	'<' ELEMENT NAME '=' '"' IDENT '"' '>'   { ajouter_element($6); }
	;

elementtype:
	'<' ELEMENT NAME '=' '"' IDENT '"' TYPE '=' '"' IDENT '"' '>' {  }
    ;

closeelt :
	'<' '/' ELEMENT '>' { } { finir_element(); } 
	;


/*********************************/
/******** ATTRIBUTE 
/*********************************/
attribute :
	'<' ATTRIBUTE NAME '=' '"' IDENT '"' TYPE '=' '"' IDENT '"' '/' '>' { attribute($6,$11); }
	| '<' ATTRIBUTE NAME '=' '"' IDENT '"' '>' restriction '<' '/' ATTRIBUTE '>' { attribute_contraint($6,$9->t,$9->l); }
	;

restriction :
	'<' RESTRICTION BASE '=' '"' IDENT '"' '>' enumeration '<' '/' RESTRICTION '>' { printf("on est la\n"); $$ = malloc(sizeof(struct listetypee) ); $$->l = $9; strcpy($$->t,$6); printf("aussi !\n"); }
	| 	'<' RESTRICTION BASE '=' '"' IDENT '"' '>' mininclusive '<' '/' RESTRICTION '>' { printf("on est la\n"); $$ = malloc(sizeof(struct listetypee) ); $$->l = $9; strcpy($$->t,$6); printf("aussi !\n"); }
	;

enumeration : 
	enumeration '<' ENUMERATION VALUE '=' '"' IDENT '"' '/' '>'  { $$ = ajouter_liste($1, $7 ); printf("ok enum  1\n"); }
	| '<' ENUMERATION VALUE '=' '"' IDENT '"' '/' '>' { $$ = ajouter_liste(new_liste(), $6 );printf("ok enum2 \n");  }
	| {printf("ok enum 3\n");}
	;

mininclusive :
	'<' MININCLUSIVE VALUE '=' '"' NUMBER '"' '/' '>' { char comp[15]; strcpy(comp,">="); strcat(comp,$6); $$ = ajouter_liste(new_liste(),comp);  }
	;

/******************************************************************************/







%%
main(int argc, char **argv)
{
	init();

  extern FILE *yyin;
  if(argc > 1) {
    if(!(yyin = fopen(argv[1], "r"))) {
      perror(argv[1]);
      return (1);
    }
  }

  if(!yyparse())
    printf("NICKEL !\n");
  else
    printf("ERREUR !\n");
} /* main */

yyerror(char *s)
{
  fprintf(stderr, "error: %s\n", s);
}
