
/* @author Marhic Jerome
/* parser for xml type files
/* to be used along with parser.y 
*/ 

%{
# include "parser.tab.h"
%}


%s BALISE
%x COMMENT

%%



"<!--"             { BEGIN COMMENT;  /* switch to comment mode (modified from flex & bison, 1st Edition, Editions O'reilly) */ }
<COMMENT>.       |
<COMMENT>\n ;                  /* throw away comment text */
<COMMENT>"-->"    { BEGIN INITIAL;  /* return to regular mode */ }



"xsd:complexType" { BEGIN BALISE; return COMPLEXTYPE; }
"xsd:sequence"	  { BEGIN BALISE; return SEQUENCE; }
"xsd:element"     { BEGIN BALISE; return ELEMENT; }
"xsd:attribute"   { BEGIN BALISE; return ATTRIBUTE; }
"xsd:restriction" { BEGIN BALISE; return RESTRICTION; }
"xsd:enumeration" { BEGIN BALISE; return ENUMERATION; }
"xsd:minInclusive" { BEGIN BALISE; return MININCLUSIVE; }


<BALISE>"type" { BEGIN INITIAL; return TYPE; }
<BALISE>"name" { BEGIN INITIAL; return NAME; }
<BALISE>"base" { BEGIN INITIAL; return BASE; }
<BALISE>"value" { BEGIN INITIAL; return VALUE; }

[a-zA-Z:\-]*	{ BEGIN BALISE; strcpy(yylval.s,yytext); return IDENT; }
[0-9]*	{BEGIN BALISE; strcpy(yylval.s,yytext); return NUMBER; }

"//".* 
"\n" 
"\r"
[ \t\s]   { /* ignore white space */ }

.	{ return yytext[0]; }

%%
